/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCoreTranslationRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreTranslation extends TableImpl<TCoreTranslationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_translation</code>
     */
    public static final TCoreTranslation T_CORE_TRANSLATION = new TCoreTranslation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreTranslationRecord> getRecordType() {
        return TCoreTranslationRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_translation.lastchange</code>.
     */
    public final TableField<TCoreTranslationRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("CURRENT_TIMESTAMP"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_translation.pk</code>.
     */
    public final TableField<TCoreTranslationRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_translation.fk_trans_key</code>.
     */
    public final TableField<TCoreTranslationRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_translation.isocode</code>.
     */
    public final TableField<TCoreTranslationRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.t_core_translation.category</code>.
     */
    public final TableField<TCoreTranslationRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.t_core_translation.value</code>.
     */
    public final TableField<TCoreTranslationRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB.nullable(false), this, "");

    private TCoreTranslation(Name alias, Table<TCoreTranslationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreTranslation(Name alias, Table<TCoreTranslationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_translation</code> table
     * reference
     */
    public TCoreTranslation(String alias) {
        this(DSL.name(alias), T_CORE_TRANSLATION);
    }

    /**
     * Create an aliased <code>common_dd.t_core_translation</code> table
     * reference
     */
    public TCoreTranslation(Name alias) {
        this(alias, T_CORE_TRANSLATION);
    }

    /**
     * Create a <code>common_dd.t_core_translation</code> table reference
     */
    public TCoreTranslation() {
        this(DSL.name("t_core_translation"), null);
    }

    public <O extends Record> TCoreTranslation(Table<O> path, ForeignKey<O, TCoreTranslationRecord> childPath, InverseForeignKey<O, TCoreTranslationRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_TRANSLATION);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreTranslationPath extends TCoreTranslation implements Path<TCoreTranslationRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreTranslationPath(Table<O> path, ForeignKey<O, TCoreTranslationRecord> childPath, InverseForeignKey<O, TCoreTranslationRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreTranslationPath(Name alias, Table<TCoreTranslationRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreTranslationPath as(String alias) {
            return new TCoreTranslationPath(DSL.name(alias), this);
        }

        @Override
        public TCoreTranslationPath as(Name alias) {
            return new TCoreTranslationPath(alias, this);
        }

        @Override
        public TCoreTranslationPath as(Table<?> alias) {
            return new TCoreTranslationPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreTranslationRecord, Integer> getIdentity() {
        return (Identity<TCoreTranslationRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreTranslationRecord> getPrimaryKey() {
        return Keys.T_CORE_TRANSLATION_PKEY;
    }

    @Override
    public List<UniqueKey<TCoreTranslationRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_TRANSLATION);
    }

    @Override
    public List<ForeignKey<TCoreTranslationRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_TRANSLATION__FK_TRANS_KEY);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_TRANSLATION__FK_TRANS_KEY, null);

        return _tCoreTranslationKey;
    }

    @Override
    public TCoreTranslation as(String alias) {
        return new TCoreTranslation(DSL.name(alias), this);
    }

    @Override
    public TCoreTranslation as(Name alias) {
        return new TCoreTranslation(alias, this);
    }

    @Override
    public TCoreTranslation as(Table<?> alias) {
        return new TCoreTranslation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslation rename(String name) {
        return new TCoreTranslation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslation rename(Name name) {
        return new TCoreTranslation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslation rename(Table<?> name) {
        return new TCoreTranslation(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation where(Condition condition) {
        return new TCoreTranslation(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslation where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslation where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslation where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslation where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslation whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
